Subject: fix for vulnerability CVE-2006-1999 for OpenTTD 0.3.5 - 0.4.7 (Denial of service (client) via UDP packet with incorrect size)
From: OpenTTD developer team <info@openttd.org>
Origin: backport, https://github.com/OpenTTD/OpenTTD/commit/4a4b860
Bug:

Clients are affected by an harmless bug when they handle UDP packets.
The first 2 bytes of each UDP packet are a 16 bit number which
specifies the size of the packet.
If this value in a received packet is invalid (for example too small)
the client returns immediately to the main menu.
This bug becomes problematic when a malicious server visible in the
master server list sends invalid replies to the queries sent from the
clients which want to play online and will be no longer able to do it
due to the returning to the main menu.

Note that this is a partial backport of trunk r4413.


Index: network_data.c
===================================================================
--- network_data.c
+++ network_data.c
@@ -125,7 +125,7 @@
 	NetworkCloseClient(cs);

 	// Clients drop back to the main menu
-	if (!_network_server) {
+	if (!_network_server && _networking) {
 		_switch_mode = SM_MENU;
 		_networking = false;
 		_switch_mode_errorstr = STR_NETWORK_ERR_LOSTCONNECTION;

